using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using Assets.Scripts.Core;
using Newtonsoft.Json;
using Oxide.Core;
using Oxide.Core.Configuration;
using Oxide.Core.Libraries;
using Oxide.Core.Plugins;
using UnityEngine;

namespace Oxide.Plugins
{
    [Info("RaidBlock", "fermensdev + ✬☯Kub4☯✬#1950", "1.0.3")]
    [Description("RaidBlock")]
    public class RaidBlock : HurtworldPlugin
    {
        EItemCode[] ForbiddenItems = new EItemCode[] {
            EItemCode.OwrongSeeds, EItemCode.CottonSeed, EItemCode.IrradiatedOwrongSeeds, EItemCode.MedusaSeeds, EItemCode.PitcherPlantSeeds, EItemCode.SucculentSeeds,
            EItemCode.FirePit, EItemCode.Fireplace, EItemCode.Blastfurnace,
            EItemCode.PoisonTrap,
            EItemCode.Fridge, EItemCode.BasicShack
        };

        void Init()
        {
            LoadData();
        }

        private void OnPlayerInput(PlayerSession session, InputControls input)
        {
            if (!input.PrimaryTrigger || session == null || !session.IsLoaded || session.WorldPlayerEntity == null)
                return;

            var ehs = session.WorldPlayerEntity.GetComponent<EquippedHandlerServer>();
            var slotNumber = ehs.GetEquippedSlotNumber();
            var item = ehs.GetEquippedItem();

            if (item != null && item.Item != null)
            {
                if (item.Item.ItemId == 144 || item.Item.ItemId == 318)
                {
                    var sessions = GameManager.Instance?.GetSessions()?.Values.Where(IsValidSession).ToList();
                    var playerPosition = session.WorldPlayerEntity.transform.position;
                    var radius = 100f;
                    var playersNear =
                      sessions.Where(
                          s =>
                              !s.SteamId.ToString().Equals(session.SteamId.ToString()) &&
                              Vector3.Distance(s.WorldPlayerEntity.transform.position,
                                  playerPosition) <= radius)
                          .ToList();

                    var preC4Amount = GetPlayerHotbarC4Amount(session);
                    var preDrillAmount = GetPlayerHotbarDrillAmount(session);
                    timer.Once(0.25f, () =>
                    {
                        var postC4Amount = GetPlayerHotbarC4Amount(session);
                        var postDrillAmount = GetPlayerHotbarDrillAmount(session);

                        if (postC4Amount >= preC4Amount && item.Item.ItemId == 144 || postDrillAmount >= preDrillAmount && item.Item.ItemId == 318)
                        {
                            return;
                        }

                        int bloc;

                        if (item.Item.ItemId == 144)
                        {
                            bloc = Convert.ToInt32(Config["ВремьяБлокаС4/минуты"]);
                        }
                        else
                        {
                            bloc = Convert.ToInt32(Config["ВремьяБлокаДрель/минуты"]);
                        }

                        var BlockT = DateTime.Now.AddMinutes(bloc);

                        foreach (var player in playersNear)
                        {
                            Raids.Add(new BlockData((ulong)player.SteamId, Convert.ToString(BlockT)));
                            hurt.SendChatMessage(player, null, Convert.ToString(Config["Сообщение"]) + Convert.ToString(bloc) + " minuty.");
                        }
                        Raids.Add(new BlockData((ulong)session.SteamId, Convert.ToString(BlockT)));
                        hurt.SendChatMessage(session, null, Convert.ToString(Config["Сообщение"]) + Convert.ToString(bloc) + " minuty.");
                        SaveData();

                    });
                }
            }

            var check = (from x in Raids where x.Id == (ulong)session.SteamId select x).Count();

            if (check <= 0) return;

            BlockData br = (from x in Raids where x.Id == (ulong)session.SteamId select x).LastOrDefault();
            DateTime date2 = DateTime.Now;
            int result = DateTime.Compare(DateTime.Parse(br.Time), date2);

            if (item == null || item.Item == null || !isItemForbidden(item.Item.ItemId) || result <= 0)
                return;

            hurt.SendChatMessage(session, null , $"<color=red>[RaidBlock]</color> Budowanie zablokowane jeszcze na {Convert.ToInt32(DateTime.Parse(br.Time).Subtract(date2).TotalSeconds)} sekund.");

            var inv = session.WorldPlayerEntity.GetComponent<PlayerInventory>();
            int d = item.Item.ItemId;
            int a = item.StackSize;
            //int slot = slotNumber;
            int chd = 0;
            var itemmanager = Singleton<GlobalItemManager>.Instance;
            var iitemc = new ItemInstance(itemmanager.GetItem(item.Item.ItemId), item.StackSize);
            var iitem0 = new ItemInstance(itemmanager.GetItem(0), item.StackSize);

            for (int bn = 0; bn < inv.Capacity; bn++)
            {
                if (inv.Items[bn] == null && chd == 0 && bn > 15)
                {
                    int slot = slotNumber;
                    inv.Items[bn] = iitemc;
                    RefreshInventory(session);
                    chd = 1;
                }
                if (bn == slotNumber)
                {
                    inv.Items[bn] = null;
                    RefreshInventory(session);
                }
            }

            var amanager = Singleton<AlertManager>.Instance;

            if (chd == 0)
            {
                int nd = UnityEngine.Random.Range(16, 25);
                var oldit = inv.Items[nd];
                inv.Items[nd] = iitemc;
                inv.Items[slotNumber] = oldit;
                RefreshInventory(session);
            }
            else
            {
                inv.Items[slotNumber] = null;
                RefreshInventory(session);
            }
        }

        void RefreshInventory(PlayerSession target)
        {
            var itemManager = GlobalItemManager.Instance;
            // Give a 0 Planks to refresh player's inventory.
            itemManager.GiveItem(target.Player, itemManager.GetItem(22), 0);
        }

        public bool IsValidSession(PlayerSession session)
        {
            return session?.SteamId != null && session.IsLoaded && session.Name != null && session.Identity != null &&
                   session.WorldPlayerEntity?.transform?.position != null;
        }

        void give(PlayerSession session, int s, int count)
        {
            var itemmanager = Singleton<GlobalItemManager>.Instance;
            itemmanager.GiveItem(session.Player, itemmanager.GetItem(s), count);
        }

        public PlayerSession FindPlayer(string playerName) => GameManager.Instance.GetSessions().Values.Where(x => x != null && x.IsLoaded && x.Name == playerName).FirstOrDefault();

        object canExtTeleport(PlayerSession session)
        {
            if (israid(session))
            {
                return true;
            }
            return null;
        }

        object canRedeemKit(PlayerSession session)
        {
            if (israid(session))
            {
                return true;
            }
            return null;
        }

        public int GetPlayerHotbarC4Amount(PlayerSession session)
        {
            var c4 = 0;
            var pInventory = session.WorldPlayerEntity?.GetComponent<PlayerInventory>();

            if (pInventory != null)
            {
                for (var i = 0; i < 8; i++)
                {
                    var item = pInventory.Items[i];

                    if (item?.Item != null && item.Item.ItemId == 144)
                    {
                        c4 += item.StackSize;
                    }
                }
            }
            return c4;
        }

        public int GetPlayerHotbarDrillAmount(PlayerSession session)
        {
            var drill = 0;
            var pInventory = session.WorldPlayerEntity?.GetComponent<PlayerInventory>();

            if (pInventory != null)
            {
                for (var i = 0; i < 8; i++)
                {
                    var item = pInventory.Items[i];

                    if (item?.Item != null && item.Item.ItemId == 318)
                    {
                        drill += item.StackSize;
                    }
                }
            }
            return drill;
        }

        void LoadData()
        {
            Raids = Interface.Oxide.DataFileSystem.ReadObject<List<BlockData>>("BlockData");
        }

        bool israid(PlayerSession session)
        {
            var check = (from x in Raids where x.Id == (ulong)session.SteamId select x).Count();

            if (check <= 0) return false;

            BlockData br = (from x in Raids where x.Id == (ulong)session.SteamId select x).LastOrDefault();
            DateTime date2 = DateTime.Now;
            int result = DateTime.Compare(DateTime.Parse(br.Time), date2);
			if(result<=0)
				return false;
			
            hurt.SendChatMessage(session, null, $"<color=red>[RaidBlock]</color> Blokada jeszcze na {Convert.ToInt32(DateTime.Parse(br.Time).Subtract(date2).TotalSeconds)} sekund.");
            return true;
        }

        void SaveData()
        {
            Interface.Oxide.DataFileSystem.WriteObject("BlockData", Raids);
        }

        protected override void LoadDefaultConfig()
        {
            PrintWarning("Создание конфига для RaidBlock");
            Config.Clear();
            Config["ВремьяБлокаС4/минуты"] = 3;
            Config["ВремьяБлокаДрель/минуты"] = 7;
            Config["Сообщение"] = "<color=red>[RaidBlock]</color> Zaczął się rajd masz blokadę na ";

            SaveConfig();
        }
        #region [LISTS]
        public List<BlockData> Raids = new List<BlockData>();

        public class BlockData
        {
            public BlockData(ulong Id, string Time)
            {
                this.Id = Id;
                this.Time = Time;
            }
            public ulong Id { get; set; }
            public string Time { get; set; }
        }

        #endregion
        bool isItemForbidden(int itemCode)
        {
            foreach (var fb in ForbiddenItems)
                if ((int)fb == itemCode)
                    return true;
            return false;
        }

        void SendNotification(PlayerSession session, string message) => AlertManager.Instance.GenericTextNotificationServer(message, session.Player);
    }
}